var UnidadeController = function (ScreenService, UnidadeService, Parametros, eventAggregator) {

	this.onEnter = function (widget) {
		widget.reload();
	};

	this.afterMoveRow = function (unit) {
		var message = "Deseja confirmar a troca de unidade?";
		ScreenService.confirmMessage(message, "question", function() {
			changeUnit(unit);
		});
	};

	var changeUnit = function(unit) {
		UnidadeService.alterarEstrutura(unit.CDFILIAL, unit.NRORG).then(function() {
			UnidadeService.updateMongoSession(unit.NMFILIAL, unit.CDFILIAL).then(function() {
				updateLocalSession(unit);
				setLocalVar('OPENMODALAF', 'N');
			}, callbackError);
		}, callbackError);
	};

	var updateLocalSession = function(unit) {
		Parametros.retornaDataProcessamento(unit.CDFILIAL, unit.NRORG).then(function (dtprocessa) {
			unit.DTPROCESSA = dtprocessa;
			setLocalVars(unit);
			buildUserAndHeader();
			eventAggregator.publish("onUnitChange", unit);
			ScreenService.openWindow('product#dashboard');
		}, callbackError);
	};

	function buildUserAndHeader() {
		var nmoperador = getLocalVar('NMOPERADOR');
		var dtprocessa = getLocalVar('DTPROCESSA');
		var cdfilial = getLocalVar('CDFILIAL');
		var nmfilial = getLocalVar('NMFILIAL');
		var unidade = cdfilial + " - " + nmfilial;
		var headerInfo = dtprocessa + " | " + unidade;
		ScreenService.buildUserData(nmoperador, [dtprocessa, unidade], userMethod);
		ScreenService.setHeaderInfo(headerInfo);
	}

	function userMethod() {
		// @todo create user profile window
	}

	var setLocalVars = function (unidade) {
		setLocalVar("CDFILIAL", unidade.CDFILIAL);
		setLocalVar("NMFILIAL", unidade.NMFILIAL);
		setLocalVar("DTPROCESSA", unidade.DTPROCESSA);
	};

	var callbackError = function(err) {
		ScreenService.showMessage(JSON.stringify(err.data));
	};

};

Configuration(function (ContextRegister) {
	ContextRegister.register('UnidadeController', UnidadeController);
});